// cl Client2.cpp Strings.cpp /O1 /Os /GS- /GR- /link TCLib.lib kernel32.lib user32.lib gdi32.lib UUID.lib ole32.lib oleaut32.lib 
// 11,776 bytes; 17,920 bytes grid
#define     UNICODE             // COM uses wide character OLE Strings.
#define     _UNICODE            // This one is for the C Runtime includes
#include    <windows.h>         // This code requires three other files of mine, i.e., Client7.h, Strings.h,
#include    <objbase.h>         // and Strings.cpp.  All the other includes are SDK includes.
#include    <ocidl.h>
#include    "stdio.h"
#include    "tchar.h"
#include    "Client2.h"
#include    "Strings.h"
const CLSID CLSID_FHGrid        =  {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}};
const IID   IID_IFHGrid         =  {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01}};
const IID   IID_IFHGridEvents   =  {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02}};
const IID   LIBID_FHGrid        =  {0x30000000, 0x0000, 0x0000, {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03}};
extern "C"  int _fltused        =  1;


int _cdecl _purecall(void)   // Won't link against TCLib.lib without this useless function!
{
 return 0;
}


interface IGrid : IUnknown
{
 virtual HRESULT STDMETHODCALLTYPE CreateGrid          (HWND hParent, BSTR strSetup, int x, int y, int cx, int cy, int iRows, int iCols, int iRowHt, int iSelBkClr, int iSelTxtClr, BSTR strFntNme, int iFntSz, int iFntWt) = 0;
 virtual HRESULT STDMETHODCALLTYPE SetRowCount         (int iRowCount, int blnForce) = 0;
 virtual HRESULT STDMETHODCALLTYPE GetRowCount         (int* pRowCount) = 0;
 virtual HRESULT STDMETHODCALLTYPE SetData             (int iRow, int  iCol, BSTR strData) = 0;
 virtual HRESULT STDMETHODCALLTYPE GetData             (int iRow, int iCol, BSTR* strData) = 0;
 virtual HRESULT STDMETHODCALLTYPE FlushData           (void) = 0;
 virtual HRESULT STDMETHODCALLTYPE Refresh             (void) = 0;
 virtual HRESULT STDMETHODCALLTYPE GetVisibleRows      (int* pVisibleRows) = 0;
 virtual HRESULT STDMETHODCALLTYPE GethGrid            (HWND* hWnd) = 0;
 virtual HRESULT STDMETHODCALLTYPE GethCell            (int iRow, int iCol, HWND* hCell) = 0;
 virtual HRESULT STDMETHODCALLTYPE GethComboBox        (int iCol, HWND* hCombo) = 0;
 virtual HRESULT STDMETHODCALLTYPE SetCellAttributes   (int iRow, int iCol, int iBackColor, int iTextColor) = 0;
 virtual HRESULT STDMETHODCALLTYPE DeleteRow           (int iRow) = 0;
};


interface IGridEvents : IUnknown
{
 virtual HRESULT STDMETHODCALLTYPE Grid_OnKeyPress     (int iKeyCode, int iKeyData, int iRow, int iCol, int* blnCancel) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnKeyDown      (int KeyCode, int iKeyData, int iCellRow, int iGridRow, int iCol, int* blnCancel) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnLButtonDown  (int iCellRow, int iGridRow, int iCol) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnLButtonDblClk(int iCellRow, int iGridRow, int iCol) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnPaste        (int iCellRow, int iGridRow, int iCol) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnRowSelection (int iRow, int iAction) = 0;
 virtual HRESULT STDMETHODCALLTYPE Grid_OnDelete       (int iRow) = 0;
};


class CSink : public IGridEvents                        //CSink
{
 public:
 CSink();
 ~CSink();
 HRESULT STDMETHODCALLTYPE QueryInterface               (REFIID iid, void** ppv);
 ULONG   STDMETHODCALLTYPE AddRef                       ();
 ULONG   STDMETHODCALLTYPE Release                      ();
 HRESULT STDMETHODCALLTYPE Grid_OnKeyPress              (int iKeyCode, int iKeyData, int iRow, int iCol, int* blnCancel);
 HRESULT STDMETHODCALLTYPE Grid_OnKeyDown               (int KeyCode, int iKeyData, int iCellRow, int iGridRow, int iCol, int* blnCancel);
 HRESULT STDMETHODCALLTYPE Grid_OnLButtonDown           (int CellRow, int GridRow, int Col);
 HRESULT STDMETHODCALLTYPE Grid_OnLButtonDblClk         (int CellRow, int GridRow, int Col);
 HRESULT STDMETHODCALLTYPE Grid_OnPaste                 (int CellRow, int GridRow, int Col);
 HRESULT STDMETHODCALLTYPE Grid_OnRowSelection          (int iRow, int iAction);
 HRESULT STDMETHODCALLTYPE Grid_OnDelete                (int iRow);

 private:
 HWND m_hWnd;
 long m_cRef;
};


CSink::CSink() : m_cRef(0), m_hWnd(0)
{
 this->m_hWnd = FindWindow(_T("64 Bit Grid"),_T("64 Bit Grid ActiveX Control"));
}


CSink::~CSink()
{
 //_tprintf(_T("      Entering CSink Destructor!\n"));
}


ULONG CSink::AddRef()
{
 ++this->m_cRef;
 return m_cRef;
}


ULONG CSink::Release()
{
 if(--m_cRef != 0)
    return m_cRef;
 else
    delete this;

 return 0;
}


HRESULT CSink::QueryInterface(REFIID riid, void** ppv)
{
 if(riid == IID_IUnknown)
    *ppv = (IUnknown*)this;
 else if(riid == IID_IFHGridEvents)
    *ppv = (IGridEvents*)this;
 else
 {
    *ppv = NULL;
    return E_NOINTERFACE;
 }
 AddRef();

 return S_OK;
}


HRESULT CSink::Grid_OnKeyPress(int KeyCode, int KeyData, int Row, int Col, int* blnCancel)
{
 //_tprintf(_T("\nEntering CSink::Grid_OnKeyPress()\n"));
 return S_OK;
}


HRESULT CSink::Grid_OnKeyDown(int KeyCode, int iKeyData, int iCellRow, int iGridRow, int iCol, int* blnCancel)
{
 //_tprintf(_T("\nEntering CSink::Grid_OnKeyDown()\n"));
 return S_OK;
}


HRESULT CSink::Grid_OnLButtonDown(int iCellRow, int iGridRow, int iCol)
{
 //_tprintf(_T("\nEntering CSink::Grid_OnLButtonDown()\n"));
 return S_OK;
}


HRESULT CSink::Grid_OnLButtonDblClk(int iCellRow, int iGridRow, int iCol)
{
 return S_OK;
}


HRESULT CSink::Grid_OnPaste(int iCellRow, int iGridRow, int iCol)
{
 return S_OK;
}


HRESULT CSink::Grid_OnRowSelection(int iRow, int iAction)
{
 if(this->m_hWnd)
 {
    if(iAction)
       SetWindowLongPtr(this->m_hWnd,2*sizeof_ptr,(LONG_PTR)iRow);
    else
       SetWindowLongPtr(this->m_hWnd,2*sizeof_ptr,(LONG_PTR)iAction);
 }
 
 return S_OK;
}


HRESULT CSink::Grid_OnDelete(int iRow)
{
 IGrid* pGrid=(IGrid*)GetWindowLongPtr(this->m_hWnd,0*sizeof_ptr);
 if(pGrid)
 {
    pGrid->DeleteRow(iRow);
    SetWindowLongPtr(this->m_hWnd,2*sizeof_ptr,(LONG_PTR)0);
 }
 
 return S_OK;
}


long fnWndProc_OnCreate(WndEventArgs& Wea)
{
 HRESULT (__stdcall* ptrDllGetClassObject) (const CLSID&, const IID&, void**);  // code for registry free com
 IConnectionPointContainer* pConnectionPointContainer=NULL;
 BSTR strSetup=NULL,strFontName=NULL,strCoordinate=NULL;
 IConnectionPoint* pConnectionPoint=NULL;
 IClassFactory* pClassFactory=NULL;
 double dpiX,dpiY,rxRatio,ryRatio;
 CSink* pSink=NULL;
 IGrid* pGrid=NULL;
 HMODULE hDll=NULL;
 DWORD dwCookie=0;
 String s1,s2,s3;
 HWND hCtl=NULL;
 int iGridRows;
 HDC hDC=NULL;
 HRESULT hr;

 Wea.hIns=((LPCREATESTRUCT)Wea.lParam)->hInstance;
 hDC = GetDC(NULL);
 dpiX=GetDeviceCaps(hDC, LOGPIXELSX);
 dpiY=GetDeviceCaps(hDC, LOGPIXELSY);
 rxRatio=(dpiX/96);
 ryRatio=(dpiY/96);
 MoveWindow(Wea.hWnd,SizX(200),SizY(100),SizX(840),SizY(340),TRUE);
 hr=CoInitialize(NULL);
 if(SUCCEEDED(hr))
 {
    hCtl=CreateWindow(_T("button"),_T("Get Cell (3,2) Data"),WS_CHILD|WS_VISIBLE,SizX(10),SizY(10),SizX(200),SizY(30),Wea.hWnd,(HMENU)IDC_GET_DATA,Wea.hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Get Selected Row"),WS_CHILD|WS_VISIBLE,SizX(10),SizY(50),SizX(200),SizY(30),Wea.hWnd,(HMENU)IDC_GET_SELECTED_ROW,Wea.hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Get Row Count"),WS_CHILD|WS_VISIBLE,SizX(10),SizY(90),SizX(200),SizY(30),Wea.hWnd,(HMENU)IDC_GET_ROW_COUNT,Wea.hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Set Row Count"),WS_CHILD|WS_VISIBLE,SizX(10),SizY(130),SizX(200),SizY(30),Wea.hWnd,(HMENU)IDC_SET_ROW_COUNT,Wea.hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Get hCell"),WS_CHILD|WS_VISIBLE,SizX(10),SizY(170),SizX(200),SizY(30),Wea.hWnd,(HMENU)IDC_GET_HCELL,Wea.hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Color Some Rows"),WS_CHILD|WS_VISIBLE,SizX(10),SizY(210),SizX(200),SizY(30),Wea.hWnd,(HMENU)IDC_COLOR_SOME_ROWS,Wea.hIns,NULL);
    hCtl=CreateWindow(_T("button"),_T("Destroy Grid"),WS_CHILD|WS_VISIBLE,SizX(10),SizY(250),SizX(200),SizY(30),Wea.hWnd,(HMENU)IDC_UNLOAD_GRID,Wea.hIns,NULL);
    hDll=LoadLibrary(L"FHGrid.dll");
    if(hDll)
    { 
       ptrDllGetClassObject=(HRESULT (__stdcall*)(REFCLSID, REFIID, void**))GetProcAddress(hDll,"DllGetClassObject");
       hr=ptrDllGetClassObject(CLSID_FHGrid,IID_IClassFactory,(void**)&pClassFactory);  
       if(SUCCEEDED(hr))
       {     
          hr=pClassFactory->CreateInstance(NULL,IID_IFHGrid,(void**)&pGrid);
          if(SUCCEEDED(hr))
          {
             SetWindowLongPtr(Wea.hWnd,0*sizeof_ptr,(LONG_PTR)pGrid);
             strSetup   = SysAllocString(L"110:Column 1:^:combo,110:Column 2:^:edit,110:Column 3:^:edit,110:Column 4:^:edit,110:Column 5:^:edit");
             strFontName= SysAllocString(L"Times New Roman");
             hr=pGrid->CreateGrid(Wea.hWnd,strSetup,SizX(250),SizY(10),SizX(570),SizY(273),NUMBER_OF_ROWS,NUMBER_OF_COLUMNS,SizY(28),0,0,strFontName,18,FW_DONTCARE);
             if(SUCCEEDED(hr))
             {
                hr=pGrid->QueryInterface(IID_IConnectionPointContainer,(void**)&pConnectionPointContainer);
                if(SUCCEEDED(hr))
                {
                   hr = pConnectionPointContainer->FindConnectionPoint(IID_IFHGridEvents, &pConnectionPoint);
                   if(SUCCEEDED(hr))
                   {
                      pSink=new CSink;
                      if(pSink)
                      {
                         hr=pConnectionPoint->Advise((IUnknown*)pSink, &dwCookie);
                         if(SUCCEEDED(hr))
                         {
                            SetWindowLongPtr(Wea.hWnd,1*sizeof_ptr,(long)dwCookie);
                            for(unsigned int i=1; i<=NUMBER_OF_ROWS; i++)
                            {
                                s1=i;
                                for(unsigned int j=1; j<=NUMBER_OF_COLUMNS; j++)
                                {
                                    s2=j;
                                    s3=s1+_T(',')+s2;
                                    strCoordinate=SysAllocString(s3.lpStr());
                                    pGrid->SetData(i,j,strCoordinate);
                                    SysFreeString(strCoordinate);
                                }
                            }
                            hCtl=0;
                            hr=pGrid->GethComboBox(1,&hCtl);
                            if(SUCCEEDED(hr))
                            {
                               s1=L"Frederick", SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());
                               s1=L"Elsie",     SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());
                               s1=L"Scott",     SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());
                               s1=L"Lorrie",    SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());
                               s1=L"Joseph",    SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());
                               s1=L"Frank",     SendMessage(hCtl,CB_INSERTSTRING,-1,(LPARAM)s1.lpStr());
                            }
                            pGrid->Refresh();
                         }
                      }
                      pConnectionPoint->Release();
                   }
                   pConnectionPointContainer->Release();
                }
             }
             SysFreeString(strSetup);
             SysFreeString(strFontName);
          }
       }
       pClassFactory->Release();
    }
 }

 return 0;
}


void DestroyGrid(HWND hHost)
{
 IConnectionPoint* pConnectionPoint=NULL;
 DWORD dwCookie=123456;

 IGrid* pGrid=(IGrid*)GetWindowLongPtr(hHost,0);
 if(pGrid)
 {
    dwCookie=(DWORD)GetWindowLongPtr(hHost,1*sizeof_ptr);
    HRESULT hr=pGrid->QueryInterface(IID_IConnectionPoint,(void**)&pConnectionPoint);
    if(SUCCEEDED(hr))
    {
       hr=pConnectionPoint->Unadvise(dwCookie);
       pConnectionPoint->Release();
    }
    pGrid->Release();
    SetWindowLongPtr(hHost,0,NULL);
 }
}


long fnWndProc_OnCommand(WndEventArgs& Wea)
{
 switch(LOWORD(Wea.wParam))
 {
    case IDC_GET_DATA:
      {
         IGrid* pGrid=NULL;
         BSTR strData=SysAllocString(L"");
         pGrid=(IGrid*)GetWindowLongPtr(Wea.hWnd,0);
         if(pGrid)
         {
            pGrid->FlushData();
            HRESULT hr=pGrid->GetData(3,2,&strData);
            if(SUCCEEDED(hr))
            {
               String s1=_T("strData = ");
               s1=s1+strData;
               MessageBox(Wea.hWnd,s1.lpStr(),_T("pGrid->GetData()"),MB_OK);
            }
            SysFreeString(strData);
         }
         break;
      }
    case IDC_GET_SELECTED_ROW:
      {
         int iRow=(int)GetWindowLongPtr(Wea.hWnd,2*sizeof_ptr);
         if(iRow)
         {
            TCHAR szNumber[16],szBuffer[64];
            _stprintf(szNumber,_T("%d"),iRow);
            _tcscpy(szBuffer,_T("Row # "));
            _tcscat(szBuffer,szNumber);
            _tcscat(szBuffer,_T(" Has Been Selected!"));
            MessageBox(Wea.hWnd,szBuffer,_T("Selection Results"),MB_OK);
         }
         else
            MessageBox(Wea.hWnd,_T("No Row Is Presently Selected!"),_T("Selection Results"),MB_OK);
         break;
      }
    case IDC_GET_ROW_COUNT:
      {
         IGrid* pGrid=NULL;
         pGrid=(IGrid*)GetWindowLongPtr(Wea.hWnd,0);
         if(pGrid)
         {
            int iRowCount=0;
            HRESULT hr=pGrid->GetRowCount(&iRowCount);
            if(SUCCEEDED(hr))
            {
               TCHAR szBuffer[64],szNumber[16];
               _stprintf(szNumber,_T("%d"),iRowCount);
               _tcscpy(szBuffer,_T("The Grid Has "));
               _tcscat(szBuffer,szNumber);
               _tcscat(szBuffer,_T(" Row In It."));
               MessageBox(Wea.hWnd,szBuffer,_T("Row Count Report"),MB_OK);
            }
         }
         break;
      }
    case IDC_SET_ROW_COUNT:
      {
         IGrid* pGrid=NULL;
         pGrid=(IGrid*)GetWindowLongPtr(Wea.hWnd,0);
         if(pGrid)
         {
            HRESULT hr=pGrid->SetRowCount(25,TRUE);
            if(SUCCEEDED(hr))
            {
               String s1,s2,s3;
               BSTR strCoordinate=NULL;
               for(unsigned int i=1; i<=25; i++)
               {
                   s1=i;
                   for(unsigned int j=1; j<=NUMBER_OF_COLUMNS; j++)
                   {
                       s2=j;
                       s3=s1+_T(',')+s2;
                       strCoordinate=SysAllocString(s3.lpStr());
                       pGrid->SetData(i,j,strCoordinate);
                       SysFreeString(strCoordinate);
                   }
               }
               pGrid->Refresh();
               MessageBox(Wea.hWnd,_T("pGrid->SetRowCount() Succeeded!"),_T("Report"),MB_OK);
            }
         }
         break;
      }
    case IDC_GET_HCELL:
      {
         IGrid* pGrid=NULL;
         pGrid=(IGrid*)GetWindowLongPtr(Wea.hWnd,0);
         if(pGrid)
         {
            HWND hCell=0;
            HRESULT hr=pGrid->GethCell(3,2,&hCell);
            if(SUCCEEDED(hr))
            {
               TCHAR szBuffer[32];
               TCHAR szNumber[16];
               _tcscpy(szBuffer,(TCHAR*)_T("hCell (3,2) = "));
               _stprintf(szNumber,_T("%u"),hCell);
               _tcscat(szBuffer,szNumber);
               MessageBox(Wea.hWnd,szBuffer,_T("pGrid->GethCell(3,2)"),MB_OK);
            }
         }
         break;
      }
    case IDC_COLOR_SOME_ROWS:
      {
         IGrid* pGrid=NULL;
         pGrid=(IGrid*)GetWindowLongPtr(Wea.hWnd,0);
         if(pGrid)
         {
            pGrid->FlushData();
            for(int i=1; i<=NUMBER_OF_COLUMNS; i++)
                pGrid->SetCellAttributes(3,i,0xFF,0xFFFFFF);
            for(int i=1; i<=NUMBER_OF_COLUMNS; i++)
                pGrid->SetCellAttributes(4,i,0x00FF00,0xFFFFFF);
            for(int i=1; i<=NUMBER_OF_COLUMNS; i++)
                pGrid->SetCellAttributes(5,i,0x00FF0000,0x00FFFFFF);
            for(int i=1; i<=NUMBER_OF_COLUMNS; i++)
                pGrid->SetCellAttributes(6,i,0x00FFFF,0x00);
            for(int i=1; i<=NUMBER_OF_COLUMNS; i++)
                pGrid->SetCellAttributes(7,i,0xFFFF00,0x01);
            pGrid->Refresh();
         }
         break;
      }
    case IDC_UNLOAD_GRID:
      {
         DestroyGrid(Wea.hWnd);
         InvalidateRect(Wea.hWnd,NULL,TRUE);
         EnableWindow(GetDlgItem(Wea.hWnd,IDC_UNLOAD_GRID),FALSE);
         EnableWindow(GetDlgItem(Wea.hWnd,IDC_GET_DATA),FALSE);
         EnableWindow(GetDlgItem(Wea.hWnd,IDC_GET_SELECTED_ROW),FALSE);
         EnableWindow(GetDlgItem(Wea.hWnd,IDC_GET_ROW_COUNT),FALSE);
         EnableWindow(GetDlgItem(Wea.hWnd,IDC_SET_ROW_COUNT),FALSE);
         EnableWindow(GetDlgItem(Wea.hWnd,IDC_COLOR_SOME_ROWS),FALSE);
         EnableWindow(GetDlgItem(Wea.hWnd,IDC_GET_HCELL),FALSE);
         break;
      }
 }

 return 0;
}


long fnWndProc_OnDestroy(WndEventArgs& Wea)
{
 DestroyGrid(Wea.hWnd);
 PostQuitMessage(0);
 return 0;
}


LRESULT CALLBACK WndProc(HWND hwnd, unsigned int msg, WPARAM wParam, LPARAM lParam)
{
 WndEventArgs Wea;

 for(unsigned int i=0; i<dim(EventHandler); i++)
 {
     if(EventHandler[i].iMsg==msg)
     {
        Wea.hWnd=hwnd, Wea.lParam=lParam, Wea.wParam=wParam;
        return (EventHandler[i].fnPtr)(Wea);
     }
 }

 return (DefWindowProc(hwnd, msg, wParam, lParam));
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
 TCHAR szClass[]=_T("64 Bit Grid");
 WNDCLASSEX wc;
 HWND hWnd;
 MSG Msg;

 SetProcessDPIAware();
 wc.lpszClassName=szClass,                 wc.lpfnWndProc=WndProc,                   wc.cbSize=sizeof(WNDCLASSEX);
 wc.style=0,                               wc.cbClsExtra=0,                          wc.cbWndExtra=3*sizeof_ptr;
 wc.hInstance=hInstance,                   wc.hIcon=LoadIcon(NULL,IDI_APPLICATION),  wc.hCursor=LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground=(HBRUSH)COLOR_BTNSHADOW, wc.lpszMenuName=NULL,                     wc.hIconSm=LoadIcon(NULL, IDI_APPLICATION);
 RegisterClassEx(&wc);
 hWnd=CreateWindow(szClass,_T("64 Bit Grid ActiveX Control"),WS_OVERLAPPEDWINDOW,0,0,0,0,NULL,NULL,hInstance,NULL);
 ShowWindow(hWnd,nCmdShow);
 while(GetMessage(&Msg, NULL, 0, 0))
 {
    TranslateMessage(&Msg);
    DispatchMessage(&Msg);
 }  
 CoFreeUnusedLibraries();
 CoUninitialize();

 return (int)Msg.wParam;
}
